Subject: Re: STMMAC driver: NFS Problem on 2.6.37

From: deepaksi <[email-masked]>
Date: Fri, 14 Jan 2011 15:26:33 +0530

Hi All,

On 1/13/2011 11:58 PM, Armando VISCONTI wrote:
> Chuck Lever wrote:
>   
>> On Jan 13, 2011, at 4:09 AM, deepaksi wrote:
>>
>>   
>>     
>>> Hi
>>>
>>> I am facing a problem related to nfs boot, while using the stmmac driver
>>> ported on 2.6.37 kernel. When we use a JFFS2 file system and mount the kernel,
>>> the network driver works fine.
>>>
>>> I have been following the mailing list and could find some issues with NFS 
>>> on 2.6.37 but I am not too sure whether the kernel crash I am getting is 
>>> related to that.
>>>
>>> The driver worked fine on 2.6.32 kernel, but while booting the 2.6.37
>>> kernel I get the following log messages:
>>>
>>> stmmac: Rx Checksum Offload Engine supported
>>>        TX Checksum insertion supported
>>> IP-Config: Complete:
>>>     device=eth0, addr=192.168.1.10, mask=255.255.255.0, gw=255.255.255.255,
>>>     host=192.168.1.10, domain=, nis-domain=(none),
>>>     bootserver=192.168.1.1, rootserver=192.168.1.1, rootpath=
>>>     
>>>       
>> Why is rootpath left undefined?
>>   
>>     
>   
Even with dhcp server, we get the same log for rootpath. It never
appears over there.

> Yes, Chuck.
> Good catch.
>
> Deepak,
> Can you possibly verify  your bootargs?
>
> I  see exactly your same problem with kernel 2.6.32 (rc6.3) on my
> board, where the bootargs is defined like this:
>
> bootargs=console=ttyAMA0,115200 mem=128M root=/dev/nfs 
> ip=192.168.1.10:192.168.1
> .1:192.168.1.1:255.255.255.0 nfsroot=192.168.1.1:/home/guest/armv7/target
>
> In fact, rootpath is undefined also in my case...
>
> But if I get the network info from my DHCP server the system is booting 
> correctly.
> (i.e. console=ttyAMA0,115200 mem=128M root=/dev/nfs ip=dhcp)
>
> So, why do we have rootpath undefined in our bootargs?
> I guess we screwed up something someway...
>
> Let's see it tomorrow.
>
> Ciao,
> Arm
>
>
>
>   
The nfs work fine when you use the dhcp server, but still it is a
totally different proposition. The problem comes when we assign a static
IP in the bootargs, and then try to boot the system using NFS. here is
the bootargs setting at the u-boot.

bootargs = console=ttyAMA0,115200 mem=128M root=/dev/nfs
nfsroot=192.168.1.1:/opt/STM/STLinux-2.3/devkit/arm/target
ip=192.168.1.10:192.168.1.1:192.168.1.1:255.255.255.0::eth0

These settings have been working fine for earlier kernels. The tcp dump
while doing the nfs boot is quite different between the 2.6.32 and
2.6.37 kernels.

Regards
Deepak

> .